#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <SliderConstants.au3>
#include <StaticConstants.au3>
#include <Timers.au3>
#include <WindowsConstants.au3>
#include 'bass\BassConstants.au3'
#include 'bass\Bass.au3'
#include 'bass\BassTags.au3'

Opt('GUIOnEventMode', 1)

_BASS_STARTUP('bass\bass.dll')
_Bass_Tags_Startup('bass\BassTags.dll')
_BASS_Init(0, -1, 44100, 0, '')
If @error Then Exit MsgBox(16, '', 'Fehler!' & @CRLF & 'Die Soundkarte konnte nicht initialisiert werden!')


Global $iPeakL, $iPeakR, $iHigh = 32768, $iLength, $iSeconds, $iOld
Global $iWidth = 500, $sPath, $hSoundOpen, $sID3Tags
Global $sIconDir = @ScriptDir & '\icons\'

$hGui = GUICreate('Levelmeter', 560, 225)
GUISetBkColor(0x222222)

$hLabel = GUICtrlCreateLabel('Select MP3-File...', 50, 20, 500, 28)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFAA)

GUICtrlCreateLabel('Position', 5, 51, 40, 20, $SS_RIGHT)
GUICtrlSetFont(-1, 9, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFAA)

DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0) ; Classic-Style
$hPosition = GUICtrlCreateProgress(50, 50, 500, 20, $PBS_SMOOTH)
GUICtrlSetBkColor(-1, 0x333333)
GUICtrlSetColor(-1, 0xFFAA66)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7) ; Standard-Windows-Style

$hDuration = GUICtrlCreateLabel('00:00 / 00:00', 220, 75, 120, 32)
GUICtrlSetFont(-1, 14, 400, 0, 'Tahoma')
GUICtrlSetColor(-1, 0xFFFFAA)

GUICtrlCreateLabel('Left', 5, 108, 40, 20, $SS_RIGHT)
GUICtrlSetFont(-1, 9, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFAA)

GUICtrlCreateLabel('Right', 5, 138, 40, 20, $SS_RIGHT)
GUICtrlSetFont(-1, 9, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFAA)

$hSelect = GUICtrlCreateButton('Open MP3', 250, 170, 70, 30)
GUICtrlSetOnEvent(-1, '_SelectMP3')

GUISetState()

_GDIPlus_Startup()
$hBackgr = _GDIPlus_BrushCreateSolid(0xFF222222)
$hBrushGreen = _GDIPlus_BrushCreateSolid(0xFF88FF00)
$hPenGrey = _GDIPlus_PenCreate(0xFF888888, 1)
$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hGui)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth, 44, $hGraphic)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

_GDIPlus_GraphicsFillRect($hBuffer, 0, 0, $iWidth, 44, $hBackgr)
_GDIPlus_GraphicsDrawRect($hBuffer, 0, 0, $iWidth - 1, 15, $hPenGrey)
_GDIPlus_GraphicsDrawRect($hBuffer, 0, 27, $iWidth - 1, 15, $hPenGrey)
$iWidth -= 3
_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 50, 110, $iWidth, 44)
GUISetOnEvent($GUI_EVENT_CLOSE, '_Exit')
GUIRegisterMsg($WM_TIMER, '_WM_TIMER')
$iTimerVUMeter = _Timer_SetTimer($hGui, 30)
ControlFocus($hGui, '', $hSelect)

While Sleep(10)
WEnd

Func _WM_TIMER($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $ilParam
	If $hSoundOpen <> '' Then
		Local $iLevel, $iLeft, $iRight, $iSecs, $iValL, $iValR
		Switch _Timer_GetTimerID($iwParam)
			Case $iTimerVUMeter
				$iPos = _BASS_ChannelGetPosition($hSoundOpen, $BASS_POS_BYTE)
				$iSecs = Int(_BASS_ChannelBytes2Seconds($hSoundOpen, $iPos))
				If $iSecs <> $iOld Then
					$iOld = $iSecs
					GUICtrlSetData($hDuration, _FormatTime($iSecs, $iSeconds))
				EndIf
				GUICtrlSetData($hPosition, Int(100 / $iLength * $iPos))
				$iLevel = _BASS_ChannelGetLevel($hSoundOpen)
				$iLeft = _LoWord($iLevel)
				If $iLeft > 32766 Then $iLeft = 0
				$iRight = _HiWord($iLevel)
				If $iRight > 32766 Then $iRight = 0
				If $iLeft > $iPeakL Then $iPeakL = $iLeft
				If $iRight > $iPeakR Then $iPeakR = $iRight
				$iValL = $iWidth / $iHigh * $iPeakL
				If $iValL > $iWidth Then $iValL = $iWidth
				$iValR = $iWidth / $iHigh * $iPeakR
				If $iValR > $iWidth Then $iValR = $iWidth
				_GDIPlus_GraphicsFillRect($hBuffer, 1, 3, $iValL, 10, $hBrushGreen)
				_GDIPlus_GraphicsFillRect($hBuffer, 1, 30, $iValR, 10, $hBrushGreen)
				_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 50, 110, $iWidth, 44)
				_GDIPlus_GraphicsFillRect($hBuffer, 1, 3, $iValL, 10, $hBackgr)
				_GDIPlus_GraphicsFillRect($hBuffer, 1, 30, $iValR, 10, $hBackgr)
				$iPeakL -= 1200
				$iPeakR -= 1200
		EndSwitch
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_TIMER

Func _SelectMP3()
	If $hSoundOpen <> '' Then _BASS_ChannelStop($hSoundOpen)
	$sPath = FileOpenDialog('Select MP3-File', '', 'MP3-Files (*.mp3)', 3)
	If @error Then _Exit()
	$hSoundOpen = _BASS_StreamCreateFile(False, $sPath, 0, 0, BitOR($BASS_STREAM_PRESCAN, $BASS_STREAM_AUTOFREE))
	_BASS_ChannelPlay($hSoundOpen, 0)
	$iLength = _BASS_ChannelGetLength($hSoundOpen, $BASS_POS_BYTE)
	$iSeconds = _BASS_ChannelBytes2Seconds($hSoundOpen, $iLength)
	GUICtrlSetData($hDuration, _FormatTime(0, $iSeconds))
	$sID3Tags = _Bass_Tags_Read($hSoundOpen, '%IFV2(%ARTI,%ARTI,no artist) - %IFV2(%TITL,%TITL,no title)')
	$sID3Tags = StringReplace($sID3Tags, '&', '&&')
	GUICtrlSetData($hLabel, $sID3Tags)
EndFunc   ;==>_SelectMP3

Func _Exit()
	_Timer_KillAllTimers($hGui)
	_BASS_Free()
	_GDIPlus_BrushDispose($hBackgr)
	_GDIPlus_BrushDispose($hBrushGreen)
	_GDIPlus_PenDispose($hPenGrey)
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_GraphicsDispose($hBuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_Exit

Func _FormatTime($iSecs, $iAllSecs)
	Local $iMins, $iAllMins
	$iMins = Int($iSecs / 60)
	$iSecs = Mod($iSecs, 60)
	$iAllMins = Int($iAllSecs / 60)
	$iAllSecs = Mod($iAllSecs, 60)
	Return StringFormat('%02i:%02i / %02i:%02i', $iMins, $iSecs, $iAllMins, $iAllSecs)
EndFunc   ;==>_FormatTime